Subject: Re: Bad checksum on bridge with IP options

From: David Newall <[email-masked]>
Date: Mon, 12 May 2014 23:49:30 +0930

On 12/05/14 23:21, Florian Westphal wrote:
> Agree, bridge should not alter ip options.

It would be easy to remove the call to ip_options_compile instead of 
recalculating checksum after it, but I suspect there may be good reasons 
why this, too, would be wrong.  The source file is br_netfilter.c, 
suggesting that a change in options is needed in some situations.

In the situation that caught my attention, it obviously does it wrong 
(probably didn't add 0.0.0.0 to the route record, probably just 
incremented the pointer; and seriously damaged the timestamps as well as 
an incremented pointer without actually adding a value.)

I'm in a quandary.

Is it possible that bridge has exceeded it's mandate?  I can't find it 
now, but I saw a comment that it just copies packets unchanged. I think 
it's use now goes further than that would allow.

I welcome words of advice.